#ident	"@(#)sldisconnect	1.2"
/*
 * Copyright (c) 1993 Addison-Wesley Publishing Company.
 * All rights reserved.  This source code is provided
 * for its instructional value, and is not guaranteed
 * for any particular purpose.
 */
#include <sys/types.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <netdb.h>
#include <signal.h>
#include <fcntl.h>
#include <slipcmd.h>

static char *cmd;

static void timeout(int);

void
main(int argc, char *argv[])
{
	int pfd, n, err;
	struct conninfo *cip;
	struct slcommand slcmd;
	struct sigaction sa;

	cmd = strrchr(argv[0], '/');
	if (cmd == NULL)
		cmd = argv[0];
	else
		cmd++;
	if (argc != 2) {
		fprintf(stderr, "usage: %s system\n", cmd);
		exit(1);
	}

	/*
	 * Get the information from /etc/slipsys.
	 */
	cip = getcinfo(argv[1]);
	if (cip == NULL)
		fatal("%s: can't get system information", cmd);

	/*
	 * Send the request to the slip daemon.
	 */
	slcmd.opcode = DISCONNECT;
	strcpy(slcmd.arg, argv[1]);
	pfd = open(PIPEPATH, O_RDWR);
	if (pfd < 0)
		fatal("%s: can't open pipe to slip daemon", cmd);
	n = write(pfd, &slcmd, sizeof(struct slcommand));
	if (n != sizeof(struct slcommand)) {
		if (n < 0)
			fatal("%s: can't write to slipd pipe", cmd);
		else
			fatal("%s: short write to slipd pipe", cmd);
	}
	sigemptyset(&sa.sa_mask);
	sa.sa_handler = timeout;
	sa.sa_flags = 0;
	sigaction(SIGALRM, &sa, NULL);
	alarm(30);
	n = read(pfd, &err, sizeof(int));
	alarm(0);
	if (n != sizeof(int)) {
		if (n < 0)
			fatal("%s: can't read from slipd pipe", cmd);
		else
			fatal("%s: short read from slipd pipe", cmd);
	}
	if (err == 0)
		printf("disconnected\n");
	else
		fatal("%s: can't break connection: %s", cmd,
		  strerror(err));
	exit(0);
}

static void
timeout(int signo)
{
	fatal("%s: request timed out", cmd);
}
