/*
 * Copyright (c) 1993 Addison-Wesley Publishing Company.
 * All rights reserved.  This source code is provided
 * for its instructional value, and is not guaranteed
 * for any particular purpose.
 */
#include <unistd.h>
#include <signal.h>
#include <stdio.h>

void
main()
{
	int i;
	void handler(int);

	/*
	 * Install the signal handler.
	 */
	signal(SIGINT, handler);

	/*
	 * Pause 10 times.  Only interrupted by signals.
	 */
	for (i = 0; i < 10; i++)
		pause();
}

void
handler(int sig)
{
	printf("got SIGINT\n");

	/*
	 * Open up a timing window.
	 */
	sleep(1);

	/*
	 * Reinstall the signal handler.
	 */
	signal(SIGINT, handler);
}
